'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createHiddenDataGetter = createHiddenDataGetter;
exports.createHiddenDataSetter = createHiddenDataSetter;
var HIDDEN_DATA = '$$hiddenData';

function createHiddenDataGetter(propName) {
  return new Function('obj', '\n    return obj.' + HIDDEN_DATA + ' && obj.' + HIDDEN_DATA + '.' + propName + ';\n  ');
}

function createHiddenDataSetter(propName) {
  return new Function('obj', 'data', '\n    if (!obj.hasOwnProperty("' + HIDDEN_DATA + '")) {\n      Object.defineProperty(obj, "' + HIDDEN_DATA + '", {\n        enumerable: false,\n        writable: false,\n        value: Object.create(null)\n      });\n    }\n\n    obj.' + HIDDEN_DATA + '.' + propName + ' = data;\n  ');
}